package com.persagy.dmp.admin.repository;

import com.persagy.dmp.admin.entity.AdminPermission;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.querydsl.QuerydslPredicateExecutor;

import java.util.List;

public interface AdminPermissionRepository extends JpaRepository<AdminPermission, Integer>, QuerydslPredicateExecutor<AdminPermission> {

	@Query(nativeQuery = true,
			value = "" +
					" select distinct sign                                                   " +
					"   from admin_permission p                                              " +
					"   join admin_role_permission rp on p.id = rp.permission_id             " +
					"   join admin_role r on rp.role_id = r.id                               " +
					"   join admin_user_role ur on ur.role_id = r.id                         " +
					"  where ur.user_id = ?                                                  " +
					"    and p.status = 1                                                    " +
					"    and r.status = 1                                                    " +
					"  order by sign                                                         ")
	List<String> queryForUser(Integer userId);


}

